CollationKey (Java 2 Platform SE v1.4.1_"07")

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

JavaTM 2 Platform
Std. Ed. v1.4.1_"07"

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.text
Class CollationKey

    java.lang.Object
      |
      +--java.text.CollationKey

All Implemented Interfaces:
  Comparable

public final class CollationKey
extends Object
implements Comparable

A `CollationKey` represents a `String` under the rules of a specific `Collator` object. Comparing two `CollationKey`s returns the relative order of the `String`s they represent. Using `CollationKey`s to compare `String`s is generally faster than using `Collator.compare`. Thus, when the `String`s must be compared multiple times, for example when sorting a list of `String`s. It's more efficient to use `CollationKey`s.

You can not create `CollationKey`s directly. Rather, generate them by calling `Collator.getCollationKey`. You can only compare `CollationKey`s generated from the same `Collator` object.

Generating a `CollationKey` for a `String` involves examining the entire `String` and converting it to series of bits that can be compared bitwise. This allows fast comparisons once the keys are generated. The cost of generating keys is recouped in faster comparisons when `String`s need to be compared many times. On the other hand, the result of a comparison is often determined by the first couple of characters of each `String`. `Collator.compare` examines only as many characters as it needs which allows it to be faster when doing single comparisons.

The following example shows how `CollationKey`s might be used to sort a list of `String`s.

>      // Create an array of CollationKeys for the Strings to be sorted.
>      Collator myCollator = Collator.getInstance();
>      CollationKey[] keys = new CollationKey[3];
>      keys[0] = myCollator.getCollationKey("Tom");
>      keys[1] = myCollator.getCollationKey("Dick");
>      keys[2] = myCollator.getCollationKey("Harry");
>      sort( keys );

>      //...

>      // Inside body of sort routine, compare keys this way
>      if( keys[i].compareTo( keys[j] ) > 0 )
>         // swap keys[i] and keys[j]

>      //...

>      // Finally, when we've returned from sort.
>      System.out.println( keys[0].getSourceString() );
>      System.out.println( keys[1].getSourceString() );
>      System.out.println( keys[2].getSourceString() );

See Also:
  `Collator`, `RuleBasedCollator`

Method Summary
`int` | `compareTo(CollationKey target)` Compare this CollationKey to the target CollationKey.
`int` | `compareTo(Object o)` Compares this CollationKey with the specified Object for order.
`boolean` | `equals(Object target)` Compare this CollationKey and the target CollationKey for equality.
`String` | `getSourceString()` Returns the String that this CollationKey represents.
`int` | `hashCode()` Creates a hash code for this CollationKey.
`byte[]` | `toByteArray()` Converts the CollationKey to a sequence of bits.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### compareTo

    public int compareTo(CollationKey target)

  Compare this CollationKey to the target CollationKey. The collation rules of the Collator object which created these keys are applied. Note: CollationKeys created by different Collators can not be compared.

  Parameters:
    `target` - target CollationKey
  Returns:
    Returns an integer value. Value is less than zero if this is less than target, value is zero if this and target are equal and value is greater than zero if this is greater than target.
  See Also:
    `Collator.compare(java.lang.String, java.lang.String)`

### compareTo

    public int compareTo(Object o)

  Compares this CollationKey with the specified Object for order. Returns a negative integer, zero, or a positive integer as this CollationKey is less than, equal to, or greater than the given Object.

  Specified by:
    `compareTo` in interface `Comparable`
  Parameters:
    `o` - the Object to be compared.
  Returns:
    a negative integer, zero, or a positive integer as this Collation Key is less than, equal to, or greater than the given Object.
  Throws:
    `ClassCastException` - the specified Object is not a CollationKey.
  Since:
    1.2
  See Also:
    `Comparable`

### equals

    public boolean equals(Object target)

  Compare this CollationKey and the target CollationKey for equality. The collation rules of the Collator object which created these keys are applied. Note: CollationKeys created by different Collators can not be compared.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `target` - the CollationKey to compare to.
  Returns:
    Returns true if two objects are equal, false otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Creates a hash code for this CollationKey. The hash value is calculated on the key itself, not the String from which the key was created. Thus if x and y are CollationKeys, then x.hashCode(x) == y.hashCode() if x.equals(y) is true. This allows language-sensitive comparison in a hash table. See the CollatinKey class description for an example.

  Overrides:
    `hashCode` in class `Object`
  Returns:
    the hash value based on the string's collation order.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### getSourceString

    public String getSourceString()

  Returns the String that this CollationKey represents.

### toByteArray

    public byte[] toByteArray()

  Converts the CollationKey to a sequence of bits. If two CollationKeys could be legitimately compared, then one could compare the byte arrays for each of those keys to obtain the same result. Byte arrays are organized most significant byte first.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

JavaTM 2 Platform
Std. Ed. v1.4.1_"07"

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2002 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms.